#pragma once

#include "Betriebssystem.h"

namespace Framework
{
    class Text;

    class StreamReader
    {
    public:
        //! Liet aus der Datei
        //! \param bytes Ein Array, der mit Bytes aus der Resource gefllt werden soll
        //! \param len Wie viele Bytes aus der Resource gelesen werden sollen
        virtual void lese( char *bytes, int len ) = 0;
        //! Liet die nchste zeile der Resource ein
        //! \return Die gelesene Zeile als Text mit zeilenumbruch
        virtual Text *leseZeile() = 0;
        //! Prft, ob die Resource vollstndig gelesen wurde
        //!  return 1, wenn die Resource vollstndig gelesen wurde. 0, sonst
        virtual bool istEnde() const = 0;
    };

    class Reader : public StreamReader
    {
    public:
        //! Setzt die Position des Bytes, das als nchstes gelesen werden soll
        //! \param pos Der Index des Bytes
        //! \param ende 1, wenn der Index vom ende der Resource zhlt. 0, wenn der Index vom Beginn der Resource zhlt
        virtual void setLPosition( __int64 pos, bool ende ) = 0;
        //! Gibt den Index des Bytes aus der Resource zurck, welches als nchstes gelesen werden wrde
        //! return -1, falls ein Fehler aufgetreten ist. Sonst die Position des Lesezeigers
        virtual __int64 getLPosition() const = 0;
        //! Gibt die Anzahl der zu lesenden Bytes zurck
        virtual __int64 getSize() const = 0;
    };
}