#pragma once

#include "Betriebssystem.h"

namespace Framework
{
    class Text;

    class StreamWriter
    {
    public:
        //! Schreibt in die Resource
        //! \param bytes Ein Array, der die Bytes enthlt, welche in die Resource geschrieben werden soll
        //! \param len Wie viele Bytes in die Resource geschrieben werden sollen
        virtual void schreibe( const char *bytes, int len ) = 0;
        //! Prft, ob die Resource vollstndig geschrieben wurde
        //!  return 1, wenn die Resource vollstndig geschrieben wurde. 0, sonst
        virtual bool istEnde() const = 0;
    };

    class Writer : public StreamWriter
    {
    public:
        //! Setzt die Position des Bytes, das als nchstes geschrieben werden soll
        //! \param pos Der Index des Bytes
        //! \param ende 1, wenn der Index vom ende der Resource zhlt. 0, wenn der Index vom Beginn der Resource zhlt
        virtual void setSPosition( __int64 pos, bool ende ) = 0;
        //! Gibt den Index des Bytes aus der Resource zurck, welches als nchstes geschrieben werden wrde
        //! return -1, falls ein Fehler aufgetreten ist. Sonst die Position des Schreibzeigers
        virtual __int64 getSPosition() const = 0;
        //! Gibt die Anzahl der zu schreibenden Bytes zurck
        virtual __int64 getSize() const = 0;
    };
}